%define name lastfm-player
%define oname player
%define version 1.5.4.27091

Summary: Last.fm web radio player
Name: %{name}
Version: %{version}
Release: %mkrel 3
Epoch: 1
#gw fetched from svn://svn.audioscrobbler.net/clientside/Last.fm/tags/1.5.4
#with useless binaries and other files removed (just like the Debian folks
#did with their dfsg tarballs):
#rm -rf bin/*dll bin/sqldrivers/ bin/Microsoft* bin/*lib res/libsamplerate/ res/mad/ src/Twiddly/iTunesCOMAPI/ src/breakpad/external/ src/libFingerprint/libs/ src/libUnicorn/z* src/mediadevices/ipod/include/ src/output/RtAudio/dsound/ src/output/portAudio/PortAudio/
Source0: http://cdn.last.fm/client/src/lastfm-%version.tar.xz
#Source0: http://www.mehercule.net/lastfm/lastfm_%{version}+dfsg.orig.tar.gz
Source1: icons.tar.gz
Source2: trayicons22.tar.bz2
# gw these patches come from the unofficial Debian package at:
# http://mehercule.net/staticpages/index.php/lastfm
#Don't compile portAudio output plugin on Linux.
# And fix build on 64bit Fedora 13
Patch0: build-fixes.diff
# Make sure the binaries only link to the libraries that they need
Patch1: reduce-linkage.diff
# The Linux client does not do fingerprinting, so don't build it. This reduces the client's package dependencies.
Patch3: no-fingerprint-lib.diff
# With a release build, the ALSA output plugin writes noisy messages to the log file. Only make it noisy in a debug build.
Patch4: alsa-uses-qdebug.diff
# Don't segfault: make sure that the audio device is open before we write to it.
Patch5: check-soundcard-errors.diff
# Use 22x22 icons for Linux system tray.
Patch6: tray-icon-size.diff
# Hide the Scrobble Directories group in the options. It's irrelevant on Linux.
Patch7: hide-scrobbledir-option.diff
# Control the volume by spinning the mouse wheel over the system tray icon.
Patch9: tray-volume.diff
# Correctly sets the language when there is no Last.fm.conf file. If you need to change the language after that, you can do so in Tools | Options | Account.
Patch10: set-locale.diff
# Don't re-run the setup dialog each time the program starts
Patch12: set-firstrun-status.diff
# Small style when using Qt >= 4.5
Patch13: qt45.diff
# Fix some text/icon display issues with Qt >= 4.6
Patch14: qt46.diff
# Fix warnings when compiling with Qt >= 4.7
Patch15: qt47.diff
# Fix up icon installation path for Linux packages
Patch16: dirpaths.diff
Patch17: gcc41.diff
# loved radio is no longer supported, don't include it in the UI
Patch18: hide-loved-radio.diff
# don't scrobble tracks twice
Patch19: ipod-scrobble-fix.diff
# Explicitly select which browser to use. Set it in Tools | Options | Connection.
Patch52: browser-select.diff
#gw fix linking of the ipod plugin
Patch100: fix-linking.patch
#gw official patch to prevent a crash
Patch200: sidebar-crash-fix.diff
License: GPLv2+
Group: Sound
Url: http://www.last.fm/tools/downloads/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: qt4-devel >= 2:4.3.0 qt4-linguist
BuildRequires: libalsa-devel
#gw ATM not needed on Linux
#BuildRequires: fftw3-devel libsamplerate-devel
BuildRequires: libgpod-devel
BuildRequires: libmad-devel
Provides: player
Obsoletes: player

%description
This is the custom radio player program for last.fm, formerly known as
audioscrobbler.com.

%prep
%setup -q -a 1 -n lastfm-%{version}
%apply_patches
#gw hack to remove patches for backports
%if %mdvver < 201100
%patch15 -p1 -R
%endif
%if %mdvver < 201010
%patch14 -p1 -R
%endif

bzcat %{SOURCE2} | tar -C bin/data/icons -xf - 

chmod -R +r .
perl -pi -e "s|\r\n|\n|" ChangeLog.txt

%build
%{qt4dir}/bin/qmake -config release
%make CXX="g++ -fPIC $(pkg-config --cflags libgpod-1.0)" libdir=%_libdir datadir=%_datadir

cd i18n
%{qt4dir}/bin/lrelease *.ts
mkdir -p ../bin/data/i18n
cp *.qm ../bin/data/i18n
cd ..

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p %buildroot{%_bindir,%_libdir/}
cp -r bin %buildroot%_libdir/%name
cat << EOF > %buildroot%_bindir/%name
#!/bin/sh
RUNDIR="%_libdir/%name"
export LD_LIBRARY_PATH="\${RUNDIR}\${LD_LIBRARY_PATH:+:\$LD_LIBRARY_PATH}"
exec "\${RUNDIR}/last.fm" "$@"
EOF
install -d -m 755 $RPM_BUILD_ROOT%_datadir/services 
cat > $RPM_BUILD_ROOT%_datadir/services/lastfm.protocol << EOF
[Protocol]
 exec=%_bindir/%name "%u"
 protocol=lastfm
 input=none
 output=none
 helper=true
 listing=
 reading=false
 writing=false
 makedir=false
 deleting=false
EOF

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
cat > $RPM_BUILD_ROOT%{_datadir}/applications/mandriva-%{name}.desktop << EOF
[Desktop Entry]
Name=Last.FM Player
Comment=Play the last.fm internet radio
Exec=%name %U
Icon=lastfm
Terminal=false
Type=Application
StartupNotify=true
Categories=Qt;AudioVideo;Audio;Player;X-MandrivaLinux-CrossDesktop;
EOF

mkdir -p %buildroot%_datadir/icons
cp -r icons/hicolor %buildroot%_datadir/icons/hicolor
find %buildroot -name .svn |xargs rm -rf

rm -f %buildroot%_libdir/%name/*.{lib,dylib}
#gw the dirpaths patch expects the data files there:
mv %buildroot%_libdir/%name/data %buildroot%_datadir/lastfm

#gw mac icons:
rm -f %buildroot%_datadir/%name/{icons/systray,about,install,wizard}_mac.png
#gw just for Windows:
rm -f %buildroot%_libdir/%name/LastFM.exe.config

%clean
rm -rf $RPM_BUILD_ROOT

%if %mdkversion < 200900
%post
%update_menus
%update_icon_cache hicolor
%endif

%if %mdkversion < 200900
%postun
%clean_menus
%clean_icon_cache hicolor
%endif

%files
%defattr(-,root,root)
%doc ChangeLog.txt README
%attr(755,root,root) %_bindir/%name
%_datadir/applications/mandriva-*
%_datadir/icons/hicolor/*/apps/lastfm*
%_libdir/%name
%_datadir/lastfm
%_datadir/services/lastfm.protocol


%changelog
* Wed Dec 08 2010 Götz Waschk <waschk@mandriva.org> 1:1.5.4.27091-3mdv2011.0
+ Revision: 616310
- fix a crash

* Tue Dec 07 2010 Götz Waschk <waschk@mandriva.org> 1:1.5.4.27091-2mdv2011.0
+ Revision: 613565
- add  more debian patches
 * hide loved radio
 * fix ipod scrobbling
- replace patch 101 by debian version

* Fri Nov 26 2010 Götz Waschk <waschk@mandriva.org> 1:1.5.4.27091-1mdv2011.0
+ Revision: 601547
- use updated tarball with correct version number
- put in crossdesktop category, as this is the only working last.fm application

* Wed Nov 03 2010 Götz Waschk <waschk@mandriva.org> 1:1.5.4.26862-4mdv2011.0
+ Revision: 592808
- new source snapshot
- rediff patches 0,15,52
- patch 101: build fix for gcc 4.5
- update file list

* Tue Oct 26 2010 Colin Guthrie <cguthrie@mandriva.org> 1:1.5.4.26862-3mdv2011.0
+ Revision: 589471
- fix CVE-2010-3362 properly (shell expansion at runtime, not build time)

* Sun Oct 24 2010 Oden Eriksson <oeriksson@mandriva.com> 1:1.5.4.26862-2mdv2011.0
+ Revision: 587885
- fix CVE-2010-3362 (debian)

* Tue Oct 19 2010 Götz Waschk <waschk@mandriva.org> 1:1.5.4.26862-1mdv2011.0
+ Revision: 586717
- fix make call
- remove files that shouldn't be packaged
- fix patches for backports
- new snapshot
- update patches from the Debian package

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

* Mon Jan 19 2009 Götz Waschk <waschk@mandriva.org> 1:1.5.1.31879-3mdv2009.1
+ Revision: 331122
- rebuild for new libgpod

* Thu Jul 24 2008 Götz Waschk <waschk@mandriva.org> 1:1.5.1.31879-2mdv2009.0
+ Revision: 245080
- move icons to the right dir

  + Funda Wang <fwang@mandriva.org>
    - clearify the license

* Thu Jul 17 2008 Funda Wang <fwang@mandriva.org> 1:1.5.1.31879-1mdv2009.0
+ Revision: 236740
- New version 1.5.1.31879
- synch patches

  + Götz Waschk <waschk@mandriva.org>
    - fix source URL

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas

* Tue Apr 15 2008 Götz Waschk <waschk@mandriva.org> 1:1.4.2.58240-3mdv2009.0
+ Revision: 194163
- fix typo in startup script

* Tue Apr 15 2008 Götz Waschk <waschk@mandriva.org> 1:1.4.2.58240-2mdv2009.0
+ Revision: 194054
- fix wrapper script (Moobyfr)

* Mon Apr 14 2008 Götz Waschk <waschk@mandriva.org> 1:1.4.2.58240-1mdv2009.0
+ Revision: 193156
- fix build on x86_64
- *** empty log message ***
- new version
- sync patches with the debian package
- update buildrequires
- fix build and installation

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Fri Oct 05 2007 Götz Waschk <waschk@mandriva.org> 1:1.3.2.13-1mdv2008.1
+ Revision: 95558
- new version
- update patches

* Tue Sep 11 2007 Götz Waschk <waschk@mandriva.org> 1:1.3.1.0-2mdv2008.0
+ Revision: 84577
- fix browser selection patch
- fix menu category
- drop patch 20, fixing bug #33463
- remove unused patches

  + Thierry Vignaud <tv@mandriva.org>
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Tue Jul 24 2007 Funda Wang <fwang@mandriva.org> 1:1.3.1.0-1mdv2008.0
+ Revision: 54883
- Enable browser selection patch
- refresh patches
- New version

* Sat May 19 2007 Olivier Blin <oblin@mandriva.com> 1:1.1.3-2mdv2008.0
+ Revision: 28409
- add back menu macros


* Tue Apr 03 2007 Götz Waschk <waschk@mandriva.org> 1.1.3-1mdv2007.1
+ Revision: 150239
- fix buildrequires
- no more update-menus

  + Frederic Crozat <fcrozat@mandriva.com>
    - Release 1.1.3
    - Remove patches 0 (no longer needed), 10 (merged)
    - Update patches 2, 3, 4, 5, 6, 9, 13
    - Patch0 (mehercule): fix user config path
    - Patch14 (mehercule): fix translations support
    - Patch15 (mehercule): Add 22x22 tray icon

* Tue Jan 23 2007 Götz Waschk <waschk@mandriva.org> 1:1.0.9.6-1mdv2007.1
+ Revision: 112420
- Import lastfm-player

* Tue Jan 23 2007 Götz Waschk <waschk@mandriva.org> 1.0.9.6-1mdv2007.1
- synchronize patches with Debian
- new version

* Thu Aug 03 2006 Götz Waschk <waschk@mandriva.org> 1.0.0.1-0.2113.2mdv2007.0
- fix crash on play by switching to oss

* Tue Jul 25 2006 Götz Waschk <waschk@mandriva.org> 1:1.0.0.1-0.2113.1mdv2007.0
- drop patch
- new version

* Thu Jun 29 2006 Götz Waschk <waschk@mandriva.org> 1.1.90-0.2099.3mdv2007.0
- fix xdg menu

* Wed Jun 28 2006 Götz Waschk <waschk@mandriva.org> 1.1.90-0.2099.2mdv2007.0
- fix build with gcc 4.1
- xdg menu

* Fri Apr 07 2006 Götz Waschk <waschk@mandriva.org> 1.1.90-0.2099.1mdk
- drop patch
- change license to GPL
- new snapshot

* Fri Feb 10 2006 Götz Waschk <waschk@mandriva.org> 1.1.5-0.1988.1mdk
- fix build on x86_64
- new version

* Tue Jan 31 2006 Götz Waschk <waschk@mandriva.org> 1.1.4-0.1933.1mdk
- new version

* Tue Dec 20 2005 Götz Waschk <waschk@mandriva.org> 1.1.3-0.1907.1mdk
- new version

* Mon Dec 12 2005 Götz Waschk <waschk@mandriva.org> 1.1.1-0.1892.3mdk
- fix buildrequires

* Sun Dec 11 2005 Anssi Hannula <anssi.hannula@gmail.com> 1.1.1-0.1892.2mdk
- fix lib64 build

* Wed Dec 07 2005 Götz Waschk <waschk@mandriva.org> 1.1.1-0.1892.1mdk
- fix build
- ne version

* Sat Oct 01 2005 Götz Waschk <waschk@mandriva.org> 1.0.4-1mdk
- New release 1.0.4

* Fri Aug 26 2005 Götz Waschk <waschk@mandriva.org> 1.0.3-1mdk
- new version

* Tue Aug 16 2005 Götz Waschk <waschk@mandriva.org> 1.0.1-1mdk
- fix qmake call
- fix the version number

* Sat Aug 13 2005 Götz Waschk <waschk@mandriva.org> 0-0.20050812.4mdk
- fix the program icons

* Sat Aug 13 2005 Götz Waschk <waschk@mandriva.org> 0-0.20050812.3mdk
- add KDE protocol handler (Nick Brown)

* Sat Aug 13 2005 Götz Waschk <waschk@mandriva.org> 0-0.20050812.2mdk
- rename from player

* Sat Aug 13 2005 Götz Waschk <waschk@mandriva.org> 0-0.20050812.1mdk
- initial package

